'	ASPX C# & VB.Net Compiler Call Script - 02/20/03 Ver. 1.1
' 	Author: Mike Jaffe - mjaffe02@yahoo.com
'
'	Additional Author:
'			Michael 'Flynn' Volz - michael.volz@epost.de
'	
'	Description (Mike Jaffe):
'	Since ASP.NET has arrived I feel as though I've been forced to use VS.NET. 
'	But I can't seem to sway from Homesite completely. I just love it too much. 
'	So this is my first attempt at making my version of homesite as .net ready as possible.
'	What I have written is a C# compiler for ASP.NET code behind pages.  
'	All it does is dynamically create a .bat file in the HomeSite root and then runs the cs / vb .net compiler. 
' 	The script then creates the /bin directory and copies the compiled .dll to the directory. 
'	Then it runs the internal HS browser to preview the .aspx file (Assuming your aspx has the same base name. ex myClass.aspx / myClass.aspx.cs|myClass.aspx.vb )
'	Its a pretty straight forward script. But this script along with the smNetServerControls seems to make .Net development in homesite much easier. 	
'
'	V1.1 Changes (Made by Michael 'Flynn' Volz)
'		- Added VB.Net compiler call
'		- Added autodection for CS & VB code
'		- Added ImportCommand statement for libraries to include during compilation.
'		  Example(Put this line in the header of your sourcefile):

'ImportCommand = System.dll,System.Data.dll,System.Web.dll,System.Xml.dll


'	Requirements:
'	.Net Framework and IIS
'	HomeSite 5, 5.2+ (Haven't tested it with 4.5)
'
'
'	DISCLAIMER OF WARRANTY
'
'	ASPX C# & VB.Net Compiler Call Script is provided as free software, in the hope that it will be
'	useful. It is provided "as-is", without warranty of any kind, either
'	expressed or implied, including, but not limited to, the implied warranties
'	of merchantability and fitness for a particular purpose. The entire risk as
'	to determining the suitability, quality and performance of HS ASPX C Sharp Compiler is
'	with you. Should HS ASPX C Sharp Compiler prove defective, the full cost of repair,
'	servicing, or correction lies with you.

Sub Main
	backSlash											= Chr(92)
	Set activeApp										= Application
	Dim fsObj
	Set fsObj											= CreateObject("Scripting.FileSystemObject")
	BatFilename											= "codeBehindCompile.bat"
	Set BatFile											= fsObj.CreateTextFile(activeApp.AppPath & BatFilename, true)
	lsFileName											= activeApp.ActiveDocument.Filename
	lsFolder											= activeApp.ExtractFilePath(lsFileName) 
	cmdIdentifier										= "'ImportCommand = "
	cmdLine												= ""
	

	If LCase( Right(lsFileName, 2) ) = LCase("VB") Then
		extension										= "vb"
	ElseIf LCase(Right(lsFileName, 2)) = LCase("CS") Then
		extension										= "cs"

	Else
		response										= activeApp.MessageBox("This file is neither CSharp nor VB.Net!", "", 0)
		Exit Sub

	End if

	activeApp.ActiveDocument.Save
	
	If fsObj.FolderExists(lsFolder & "bin") then
		outfolder										= lsFolder & "bin" & backSlash
	Else
		fsObj.CreateFolder(lsFolder & "bin" & backSlash)
		outfolder										= lsFolder & "bin" & backSlash
	End If
	
	outFile												= outFolder & replace(activeApp.ExtractFileName(lsFileName), extension, "dll")
	

	For i = 0 to (activeApp.ActiveDocument.LineCount - 1)
		If LCase( Left(activeApp.ActiveDocument.Lines(i), Len(cmdIdentifier)) ) = LCase(cmdIdentifier) Then
			cmdLine										= Trim(Mid( activeApp.ActiveDocument.Lines(i), Len(cmdIdentifier) + 1, (Len(activeApp.ActiveDocument.Lines(i)) - Len(cmdIdentifier)) + 1 ))
			Exit For
		End If
	Next

	BatFile.writeLine									("cd " & lsFolder & vbcr)
	BatFile.writeLine									(extension & "c /t:library /r:" & cmdLine & " /out:" & outFile & " " & lsFileName)
	BatFile.writeLine									("pause " & vbcr)
	BatFile.Close()
	
	Set BatFile											= Nothing
	Set fsObj											= Nothing
	activeApp.ShellToAppAndWait							(activeApp.AppPath & BatFilename)
	
	'This Line Previews the aspx file, can be commented out if needed.

	activeApp.OpenFile(replace(lsFileName, "." & extension, ""))
	activeApp.CurrentView = 2
	
End Sub

